﻿----------------------------------------------------------------------------
----Author: ViperGTS96------------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------

CrosshairMod = {};
CrosshairMod.modDir = g_currentModDirectory;
CrosshairMod.defaultColor = {1,1,1,0.3};
local modDescFile = loadXMLFile("modDesc", CrosshairMod.modDir .. "modDesc.xml");
CrosshairMod.title = getXMLString(modDescFile, "modDesc.title.en");
CrosshairMod.author = getXMLString(modDescFile, "modDesc.author");
CrosshairMod.version = getXMLString(modDescFile, "modDesc.version");
delete(modDescFile);

function CrosshairMod:load(creatorConnection, isOwner)
	if g_currentMission:getIsClient() then
		local settingsFilePath = getUserProfileAppPath().."modSettings/crosshairMod.xml";
		if not fileExists(settingsFilePath) then
			copyFile(CrosshairMod.modDir.."settingsTemplate.xml", settingsFilePath, false);
		end;
		local settingsFile = loadXMLFile("crosshairMod_XML", settingsFilePath, "customCrosshairSettings");
		local r,g,b,a;
		----
		local function getColorValues(crossHairType)
			local r,g,b,a = unpack(CrosshairMod.defaultColor);
			r = Utils.getNoNil(getXMLFloat(settingsFile, "crosshairMod."..crossHairType.."#red"), r);
			g = Utils.getNoNil(getXMLFloat(settingsFile, "crosshairMod."..crossHairType.."#green"), g);
			b = Utils.getNoNil(getXMLFloat(settingsFile, "crosshairMod."..crossHairType.."#blue"), b);
			a = Utils.getNoNil(getXMLFloat(settingsFile, "crosshairMod."..crossHairType.."#alpha"), a);
			r,g,b,a = MathUtil.clamp(r, 0, 255), MathUtil.clamp(g, 0, 255), MathUtil.clamp(b, 0, 255), MathUtil.clamp(a, 0, 255);
			r,g,b,a = r/255,g/255,b/255,a/255;
			--print(tostring(r).." | "..tostring(g).." | "..tostring(b).." | "..tostring(a))
			return r,g,b,a;
		end;
		r,g,b,a = getColorValues("standardCrosshair");
		g_currentMission.customCrosshair = {r,g,b,a};
		self.aimOverlay:setColor(r, g, b, a);
		----
		r,g,b,a = getColorValues("grabObjectCrosshair");
		self.pickedUpObjectOverlay:setColor(r, g, b, a);
		----
		r,g,b,a = getColorValues("petAnimalCrosshair");
		self.petOverlay:setColor(r, g, b, a);
		----
		delete(settingsFile);
		print(CrosshairMod.title.." : Loading settings from file: "..settingsFilePath);
		print(CrosshairMod.title.." : v"..CrosshairMod.version.." by "..CrosshairMod.author.." activated");
	end;
end;

Player.load = Utils.appendedFunction(Player.load, CrosshairMod.load);